unit Unit2;

interface

uses windows, unit3, jpeg, sysutils, graphics, messages;

function GetOpenFileName(var OpenFile: tagOFNA): Bool; stdcall; external 'comdlg32.dll' name 'GetOpenFileNameA';
procedure OpenPic(FileName:string);
procedure PreparePic;
procedure DrawFrame;
procedure InitHand;

implementation

function Ang2Point(angle:extended;R:extended):expoint;// 0-360,   12:00   ,  -      R   (0,0)
 var z:integer;
begin
 if angle<0 then angle:=360+(angle-360*trunc(angle/360));
 if angle>=360 then angle:=angle-360*trunc(angle/360); //   
 z:=trunc(angle/180);
 case z of
 0:begin
   result.X:=r*-sin(pi*angle/180);
   result.Y:=r*cos(pi*angle/180);
  end;
 1:begin
   angle:=angle-180*z;
   result.X:=r*sin(pi*angle/180);
   result.Y:=r*-cos(pi*angle/180);
  end;
 end;
end;

function Doedin(x:extended):integer;
 var z:extended; y:integer;
begin
 z:=trunc(frac(x)*10);
 y:=trunc(x);
 if z<0.001 then z:=0;
 if z>4 then result:=y+1 else result:=y;
end;

procedure CaclPoints;
 var z:expoint;
begin
 z:=Ang2Point(hand.Ang1,46); //  1 
 hand.x1:=hand.x0-Doedin(z.X);  // 1 
 hand.y1:=hand.y0-Doedin(z.y);
 z:=Ang2Point(hand.Ang1+hand.Ang2,35); //  2 
 hand.x2:=hand.x1-Doedin(z.X);  // 2 
 hand.y2:=hand.y1-Doedin(z.y);
 z:=Ang2Point(hand.Ang1+hand.Ang2+hand.Ang3,11); //  3 
 hand.x3:=hand.x2-Doedin(z.X);  // 3 
 hand.y3:=hand.y2-Doedin(z.y);
end;

procedure InitHand;
begin
 hand.Ang1:=-45;    //   12:00   + /   -
 hand.Ang2:=145;
 hand.Ang3:=-45;
 hand.x0:=76;
 hand.y0:=76;
 CaclPoints;
 hand.px3:=hand.x3;
 hand.py3:=hand.y3;
end;

procedure DrawFrame;
 var {i,n,m,x,y:integer;}
 d1:hdc;
begin
 bitblt(sour.Canvas.Handle,1,1,orw,orh,buffer.Canvas.Handle,1,1,srccopy); //  
///////////// /////////////
 CaclPoints;

 sour.Canvas.Pen.Width:=2;  //  
 sour.Canvas.Pen.Color:=clgray;
 sour.Canvas.MoveTo(hand.x0,hand.y0);
 sour.Canvas.LineTo(hand.x1,hand.y1);
 sour.Canvas.LineTo(hand.x2,hand.y2);
 sour.Canvas.LineTo(hand.x3,hand.y3);

 sour.Canvas.Pen.Width:=1;
 sour.Canvas.Pen.Color:=clblack;
 sour.Canvas.Brush.Color:=clyellow;
 sour.Canvas.Ellipse(hand.x0-3,hand.y0-3,hand.x0+3,hand.y0+3);
 sour.Canvas.Ellipse(hand.x1-3,hand.y1-3,hand.x1+3,hand.y1+3);
 sour.Canvas.Ellipse(hand.x2-3,hand.y2-3,hand.x2+3,hand.y2+3);

 sour.Canvas.Brush.Color:=clred;
 sour.Canvas.Ellipse(hand.x3-3,hand.y3-3,hand.x3+3,hand.y3+3);

 buffer.Canvas.Pen.Color:=clred;
 buffer.Canvas.Pen.Width:=2;
 buffer.Canvas.MoveTo(hand.x3,hand.y3);
 buffer.Canvas.LineTo(hand.px3,hand.py3);
 hand.px3:=hand.x3;
 hand.py3:=hand.y3;
 sour.Canvas.Brush.Color:=clWhite;
//////////////////////////////////////
 d1:=getdc(mainwnd);
 bitblt(d1,px+1,py+1,orw,orh,sour.Canvas.Handle,1,1,srccopy); //  
 releasedc(mainwnd,d1);
end;

procedure PreparePic;
 var i,j:integer;
begin
  sour.PixelFormat:=pf24bit;
  buffer.PixelFormat:=pf24bit;
  orw:=sour.width;
  orh:=sour.Height;

  wrt.Left:=1; //1 - 
  wrt.Right:=orw;
  wrt.Top:=1;
  wrt.Bottom:=orh;

  grt.Left:=1;
  grt.Top:=1;
  grt.Right:=orw+1;
  grt.Bottom:=orh+1;
 //////   ///////
  sha:=tbitmap.Create;
  sha.LoadFromResourceName(hinstance,'SH');
  sha.PixelFormat:=pf24bit;
  shad:=sha.Width; ///    
  sha.Height:=shad*2;//    
  sour.Width:=sour.Width+2;  //2   
  sour.Height:=sour.Height+2;
  bitblt(sour.Canvas.Handle,1,1,sour.Width,sour.Height,sour.Canvas.Handle,0,0,srccopy); //   1 ,     
  sour.Canvas.Pen.Width:=1;
  sour.Canvas.Pen.Color:=8486528;
  sour.Canvas.MoveTo(0,0);
  sour.Canvas.LineTo(sour.Width-1,0);
  sour.Canvas.LineTo(sour.Width-1,sour.Height-1);
  sour.Canvas.LineTo(0,sour.Height-1);
  sour.Canvas.LineTo(0,0);
  sour.Width:=sour.Width+shad;
  sour.Height:=sour.Height+shad;

  for i:=((sour.Width-12) div 9) downto 0 do
   bitblt(sour.Canvas.Handle,12+i*9,sour.Height-shad,shad,shad,sha.Canvas.Handle,0,0,srccopy);

  ps:=nil;  //     
  setlength(ps,sha.Height);
  for i:=0 to High(ps) do ps[i]:=sha.scanline[i];

  for i:=0 to shad-1 do   //  -
   for j:=0 to shad-1 do begin
    ps[i+shad,j].r:=ps[j,i].r;
    ps[i+shad,j].g:=ps[j,i].g;
    ps[i+shad,j].b:=ps[j,i].b;
   end;

  for i:=((sour.Height-12) div 9) downto 0 do
   bitblt(sour.Canvas.Handle,sour.Width-shad,12+i*9,shad,shad,sha.Canvas.Handle,0,shad,srccopy);

   for i:=0 to shad-1 do   //  -
   for j:=0 to shad-1 do begin
    ps[j,i].r:=ps[(shad*2)-j-1,i].r;
    ps[j,i].g:=ps[(shad*2)-j-1,i].g;
    ps[j,i].b:=ps[(shad*2)-j-1,i].b;
   end;
  bitblt(sour.Canvas.Handle,sour.Width-shad,sour.Height-shad,shad,shad,sha.Canvas.Handle,0,0,srccopy);
  sha.Free;
/////////  ////////////
  ps:=nil;  //     
  setlength(ps,sour.Height);
  for i:=0 to High(ps) do ps[i]:=sour.scanline[i];

  GetClientRect(mainwnd,r1);
  invalidaterect(mainwnd,@r1,true);
  if FileName<>'' then
   setwindowtext(mainwnd,pchar(' Writer: '+FileName))
  else  setwindowtext(mainwnd,pchar(' Writer'));
  enablewindow(but2,true);
  enablewindow(but3,true);
end;

procedure OpenPic(FileName:string);
 var ext:string;
 MyJPEG: TJPEGImage;
begin
 ext:=ExtractFileExt(FileName);
 ext:=LowerCase(ext);
 if ext='.bmp' then begin
  sour.LoadFromFile(FileName);
 end else begin // JPEG
  MyJPEG := TJPEGImage.Create;
  try
   MyJPEG.LoadFromFile(FileName);
   sour.Width:=MyJPEG.Width;
   sour.Height:=MyJPEG.Height;
   sour.Canvas.Draw(0,0,MyJPEG);
  finally
   MyJPEG.Free;
  end;
 end;

 if (sour.width>23)and(sour.Height>23) then begin 
  PreparePic;
 end else begin
  sour.Width:=0;
  sour.Height:=0;
  enablewindow(but3,false);
  enablewindow(but2,false);
  messagebox(mainwnd,'Picture is too small','Error',MB_OK+MB_ICONWARNING);
 end; 
end;

end.
